/*
    Copyright 2008 - 2011 Denis Comtesse <comtesse@users.sourceforge.net>

    This file is part of F.L.A.W.

    F.L.A.W. is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    F.L.A.W. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with F.L.A.W.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <cstdlib>
#include <SDL.h>
#include <SDL_image.h>

using namespace std;

class Fireball {
	
	private:

		SDL_Rect rect;
		bool blitted;
		
	public:
	
		SDL_Surface *fly[10], *start[16], *end[16], *glow[10];
		
		float x;
		float y;
		int w; 
		int h; 
		int status;
		int frame;
		bool collision;
		bool slowdown;
		
		struct {
			float x;
			float y;
		} speed;
	
		void init (SDL_Surface *flysprites[10], SDL_Surface *startsprites[9], SDL_Surface *endsprites[8], SDL_Surface *glowsprites[10]);
		void statusupdate(void);
		void bordercollision(void);
		
		void blit (float screenfactor, float screenoffset);
		void blitrestore(SDL_Surface *backup, float screenoffset);

};
