/*
    Copyright 2008 - 2011 Denis Comtesse <comtesse@users.sourceforge.net>

    This file is part of F.L.A.W.

    F.L.A.W. is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    F.L.A.W. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with F.L.A.W.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "framerate.h"

void FrameRateControl::update(void){

	ticks = SDL_GetTicks ();
	tickspassed = ticks - prevticks;
	updates = 0;

	while (tickspassed > period) {
		tickspassed -= period;
		updates++;
	}

	SDL_Delay (period - tickspassed);
	prevticks = SDL_GetTicks ();
}


void FrameRateControl::setfps(int fps){
	framespersecond = fps;
	period = 1000/fps;
}

void FrameRateControl::init(void){
	prevticks = SDL_GetTicks ();
}


