/*
    Copyright 2008 - 2011 Denis Comtesse <comtesse@users.sourceforge.net>

    This file is part of F.L.A.W.

    F.L.A.W. is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    F.L.A.W. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with F.L.A.W.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <cstring>
#include <cstdlib>

#include <SDL.h>
#include <SDL_ttf.h>
#include <SDL_rotozoom.h>

using namespace std;

class Menu {
	
	public:
	
		Menu(Uint8 numelements, Uint16 spacing, bool useicons, bool centered);
		void elementactive (Uint8 element, bool active);
		void optionactive (Uint8 element, Uint8 option, bool active);
		void initoptions (Uint8 element, Uint8 numoptions);
		void nameelement(Uint8 element, const char *name);	
		void nameoption(Uint8 element, Uint8 option, const char *name);	
		void setfonts(TTF_Font *normalfont, TTF_Font *boldfont);
		void seticon(Uint8 element, SDL_Surface *surface);
		void setoption (Uint8 element, Uint8 state);
		void select (Uint8 element);
		void setjoystick(SDL_Joystick *joy);
		void nojoystick (void);
		void setspacing (Uint16 s);
		
		Uint8 getoption (Uint8 element);	
		Sint8 run (Uint16 x, Uint16 y, Uint16 w, Uint16 h);	
		float screenfactor;	

		
		
	private:
	
		Uint8 numelements, selected;
		Uint16 spacing;
		bool useicons, centered, usejoystick;
		TTF_Font *normal, *bold;
		SDL_Joystick *joy;
		
		struct {
			SDL_Surface *icon;
			char name[70];
			Uint8 numoptions, state;
			bool active, switchable;
			struct {
				char name[70];
				bool active;
			} option[20];
		} element[20];
};





