/*
    Copyright 2008 - 2011 Denis Comtesse <comtesse@users.sourceforge.net>

    This file is part of F.L.A.W.

    F.L.A.W. is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    F.L.A.W. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with F.L.A.W.  If not, see <http://www.gnu.org/licenses/>.
*/

enum {UP, UPRIGHT, RIGHT, DOWNRIGHT, DOWN, DOWNLEFT, LEFT, UPLEFT};

#include "misc.h"

#include <cmath>
#include <SDL_image.h>
#include <SDL_rotozoom.h>
#include <SDL_gfxPrimitives.h>

using namespace std;

class WizardGFX {

	public:
		SDL_Surface *walk[8][8], *hit[8][10], *fall[8][8], *burn[6], *falldown[8][8], *shield;
		void load (const char *name, bool ghost, float screenfactor, bool hq);
};


class Wizard {


	private:

		SDL_Rect rect, store;
		bool blitted;


	public:

		Uint8 points;
		float x, y;
		Uint8 w, h;
		Uint8 aidelay;
		Uint8 reaction;
		Uint8 gfxset;
		Sint8 follows;
		bool skid;
		float yoffset;
		

		struct {
			float x, y;
		} speed;

		struct {
			float x, y;
		} prevspeed;

		struct {
			float x, y;
		} aiprior;

		struct {
			Sint8 x, y;
			bool fire;
		} control;

		double aggressive, idle, risk, fear;

		SDL_Joystick *joy;
		bool joystick, ai;
		Uint8 keyboard, direction, frame, extra;
		Uint16 status, idletime, timer;

		void blit (WizardGFX *set, float screenfactor, float screenoffset);
		void blitrestore (SDL_Surface *backup, float screenoffset);
		void updatecontroller(void);
		void setspeeds(void);
		void statusupdate(void);
		void wallcollisions(void);
		void setup(Uint8 n, float screenfactor);

};








